# The smallest needed database needed for ttchess to work
# for a bigger example, see /doc/tt-sql.txt

CREATE TABLE games (
  id mediumint(9) NOT NULL auto_increment,
  dgt_board smallint(6) default NULL,
  dgt_active set('Fen','Moves','GetMoves','Connected') default NULL,
  fen varchar(100) default 'rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR',
  moves text,
  updated timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY dgt_board (dgt_board)
) TYPE=MyISAM;

