import java.util.*;

/**
 * fendiff class holds ONE change in a position,
 * that is, piece@square or piece&square (left square)
 *
 */
class fendiff {
    //    boolean secured;
    char piece;
    boolean added;
    int square;

    fenboard before;
    fenboard after;

    public fenboard getBefore() { return before; }
    public fenboard getAfter() { return after; }

    public char getPiece() { return piece; }
    public boolean isAdded() { return added; }
    public int getSquare() { return square; }

    public boolean isWhite(){
	if(piece>'A' && piece < 'Z')
	    return true;
	else
	    return false;
    }


    public boolean equals(fendiff other){
	if(getPiece() != other.getPiece()) return false;
	if(getSquare() != other.getSquare()) return false;
	if(isAdded() != other.isAdded()) return false;

	return true;
    }

    //    public void setSecured(boolean s) { secured=s; }

    public fendiff() {
	//secured=false;
    }

    public fendiff(char piece, boolean added, int square){
	set(piece,added,square);
	//secured=false;
    }

    /* Creates a fendiff, given piece>0 added and piece<0 removed */
    public fendiff(int piece, int square){
	if(piece<0){
	    this.piece = (char)(-piece);
	    added=false;
	}
	else {
	    this.piece=(char)piece;
	    added=true;
	}
	//secured=false;
	this.square=square;
    }

    public fendiff(int piece,int square, fenboard before, fenboard after){
	this.before=before;
	this.after=after;
	if(piece<0){
	    this.piece = (char)(-piece);
	    added=false;
	}
	else {
	    this.piece=(char)piece;
	    added=true;
	}
	//secured=false;
	this.square=square;

    }

    public void set(char piece, boolean added, int square){
	this.piece=piece;
	this.added=added;
	this.square=square;
    }

    public String toString() {
	String output = ""+piece;
	if(added) output += "@";
	else output += "&";
	output += (char)((square)%8+'a') + "" + (8-square/8);

	return output;
    }
}
